"use strict";

Object.defineProperty(exports, "t", {
    value: true
});

exports.default = void 0;

var _ContainerBase = require("../ContainerBase");

class PriorityQueue extends _ContainerBase.Base {
    constructor(t = [], s = ((t, s) => {
        if (t > s) return -1;
        if (t < s) return 1;
        return 0;
    }), i = true) {
        super();
        this.p = s;
        if (Array.isArray(t)) {
            this._ = i ? [ ...t ] : t;
        } else {
            this._ = [];
            t.forEach((t => this._.push(t)));
        }
        this.o = this._.length;
        const e = this.o >> 1;
        for (let t = this.o - 1 >> 1; t >= 0; --t) {
            let s = t;
            const i = this._[s];
            while (s < e) {
                let t = s << 1 | 1;
                const e = t + 1;
                let h = this._[t];
                if (e < this.o && this.p(h, this._[e]) > 0) {
                    t = e;
                    h = this._[e];
                }
                if (this.p(h, i) >= 0) break;
                this._[s] = h;
                s = t;
            }
            this._[s] = i;
        }
    }
    clear() {
        this.o = 0;
        this._.length = 0;
    }
    push(t) {
        let s = this.o;
        this.o += 1;
        this._.push(t);
        while (s > 0) {
            const i = s - 1 >> 1;
            const e = this._[i];
            if (this.p(e, t) <= 0) break;
            this._[s] = e;
            s = i;
        }
        this._[s] = t;
    }
    pop() {
        if (!this.o) return;
        const t = this._.pop();
        this.o -= 1;
        if (!this.o) return;
        let s = 0;
        const i = this.o >> 1;
        while (s < i) {
            let i = s << 1 | 1;
            const e = i + 1;
            let h = this._[i];
            const r = this._[e];
            if (e < this.o && this.p(h, r) > 0) {
                i = e;
                h = r;
            }
            if (this.p(h, t) >= 0) break;
            this._[s] = h;
            s = i;
        }
        this._[s] = t;
    }
    top() {
        return this._[0];
    }
}

var _default = PriorityQueue;

exports.default = _default;