"use strict";

Object.defineProperty(exports, "t", {
    value: true
});

exports.default = void 0;

var _ContainerBase = require("../../ContainerBase");

class TreeIterator extends _ContainerBase.ContainerIterator {
    constructor(t, e, r) {
        super(r);
        this.I = t;
        this.L = e;
        if (this.iteratorType === 0) {
            this.pre = function() {
                if (this.I === this.L.left) {
                    throw new RangeError("Tree iterator access denied!");
                }
                this.I = this.I.pre();
                return this;
            };
            this.next = function() {
                if (this.I === this.L) {
                    throw new RangeError("Tree iterator access denied!");
                }
                this.I = this.I.next();
                return this;
            };
        } else {
            this.pre = function() {
                if (this.I === this.L.right) {
                    throw new RangeError("Tree iterator access denied!");
                }
                this.I = this.I.next();
                return this;
            };
            this.next = function() {
                if (this.I === this.L) {
                    throw new RangeError("Tree iterator access denied!");
                }
                this.I = this.I.pre();
                return this;
            };
        }
    }
    get index() {
        let t = this.I;
        if (t === this.L) {
            if (this.L.parent) {
                return this.L.parent.subTreeSize - 1;
            }
            return 0;
        }
        let e = 0;
        if (t.left) {
            e += t.left.subTreeSize;
        }
        while (t !== this.L) {
            const r = t.parent;
            if (t === r.right) {
                e += 1;
                if (r.left) {
                    e += r.left.subTreeSize;
                }
            }
            t = r;
        }
        return e;
    }
    equals(t) {
        return this.I === t.I;
    }
}

var _default = TreeIterator;

exports.default = _default;