"use strict";

Object.defineProperty(exports, "t", {
    value: true
});

exports.TreeNodeEnableIndex = exports.TreeNode = void 0;

class TreeNode {
    constructor(e, t) {
        this.color = 1;
        this.key = undefined;
        this.value = undefined;
        this.left = undefined;
        this.right = undefined;
        this.parent = undefined;
        this.key = e;
        this.value = t;
    }
    pre() {
        let e = this;
        if (e.color === 1 && e.parent.parent === e) {
            e = e.right;
        } else if (e.left) {
            e = e.left;
            while (e.right) {
                e = e.right;
            }
        } else {
            let t = e.parent;
            while (t.left === e) {
                e = t;
                t = e.parent;
            }
            e = t;
        }
        return e;
    }
    next() {
        let e = this;
        if (e.right) {
            e = e.right;
            while (e.left) {
                e = e.left;
            }
        } else {
            let t = e.parent;
            while (t.right === e) {
                e = t;
                t = e.parent;
            }
            if (e.right !== t) {
                e = t;
            }
        }
        return e;
    }
    rotateLeft() {
        const e = this.parent;
        const t = this.right;
        const s = t.left;
        if (e.parent === this) e.parent = t; else if (e.left === this) e.left = t; else e.right = t;
        t.parent = e;
        t.left = this;
        this.parent = t;
        this.right = s;
        if (s) s.parent = this;
        return t;
    }
    rotateRight() {
        const e = this.parent;
        const t = this.left;
        const s = t.right;
        if (e.parent === this) e.parent = t; else if (e.left === this) e.left = t; else e.right = t;
        t.parent = e;
        t.right = this;
        this.parent = t;
        this.left = s;
        if (s) s.parent = this;
        return t;
    }
}

exports.TreeNode = TreeNode;

class TreeNodeEnableIndex extends TreeNode {
    constructor() {
        super(...arguments);
        this.left = undefined;
        this.right = undefined;
        this.parent = undefined;
        this.subTreeSize = 1;
    }
    rotateLeft() {
        const e = super.rotateLeft();
        this.recount();
        e.recount();
        return e;
    }
    rotateRight() {
        const e = super.rotateRight();
        this.recount();
        e.recount();
        return e;
    }
    recount() {
        this.subTreeSize = 1;
        if (this.left) this.subTreeSize += this.left.subTreeSize;
        if (this.right) this.subTreeSize += this.right.subTreeSize;
    }
}

exports.TreeNodeEnableIndex = TreeNodeEnableIndex;