"use strict";

Object.defineProperty(exports, "t", {
    value: true
});

exports.default = exports.OrderedMapIterator = void 0;

var _Base = _interopRequireDefault(require("./Base"));

var _TreeIterator = _interopRequireDefault(require("./Base/TreeIterator"));

function _interopRequireDefault(e) {
    return e && e.t ? e : {
        default: e
    };
}

class OrderedMapIterator extends _TreeIterator.default {
    get pointer() {
        if (this.I === this.L) {
            throw new RangeError("OrderedMap iterator access denied");
        }
        return new Proxy([], {
            get: (e, r) => {
                if (r === "0") return this.I.key; else if (r === "1") return this.I.value;
            },
            set: (e, r, t) => {
                if (r !== "1") {
                    throw new TypeError("props must be 1");
                }
                this.I.value = t;
                return true;
            }
        });
    }
    copy() {
        return new OrderedMapIterator(this.I, this.L, this.iteratorType);
    }
}

exports.OrderedMapIterator = OrderedMapIterator;

class OrderedMap extends _Base.default {
    constructor(e = [], r, t) {
        super(r, t);
        this.O = function*(e) {
            if (e === undefined) return;
            yield* this.O(e.left);
            yield [ e.key, e.value ];
            yield* this.O(e.right);
        };
        e.forEach((([e, r]) => this.setElement(e, r)));
    }
    begin() {
        return new OrderedMapIterator(this.L.left || this.L, this.L);
    }
    end() {
        return new OrderedMapIterator(this.L, this.L);
    }
    rBegin() {
        return new OrderedMapIterator(this.L.right || this.L, this.L, 1);
    }
    rEnd() {
        return new OrderedMapIterator(this.L, this.L, 1);
    }
    front() {
        if (!this.o) return undefined;
        const e = this.L.left;
        return [ e.key, e.value ];
    }
    back() {
        if (!this.o) return undefined;
        const e = this.L.right;
        return [ e.key, e.value ];
    }
    forEach(e) {
        let r = 0;
        for (const t of this) e(t, r++);
    }
    lowerBound(e) {
        const r = this.T(this.j, e);
        return new OrderedMapIterator(r, this.L);
    }
    upperBound(e) {
        const r = this.K(this.j, e);
        return new OrderedMapIterator(r, this.L);
    }
    reverseLowerBound(e) {
        const r = this.S(this.j, e);
        return new OrderedMapIterator(r, this.L);
    }
    reverseUpperBound(e) {
        const r = this.U(this.j, e);
        return new OrderedMapIterator(r, this.L);
    }
    setElement(e, r, t) {
        this.G(e, r, t);
    }
    find(e) {
        const r = this.H(this.j, e);
        if (r !== undefined) {
            return new OrderedMapIterator(r, this.L);
        }
        return this.end();
    }
    getElementByKey(e) {
        const r = this.H(this.j, e);
        return r ? r.value : undefined;
    }
    getElementByPos(e) {
        if (e < 0 || e > this.o - 1) {
            throw new RangeError;
        }
        let r;
        let t = 0;
        for (const s of this) {
            if (t === e) {
                r = s;
                break;
            }
            t += 1;
        }
        return r;
    }
    union(e) {
        e.forEach((([e, r]) => this.setElement(e, r)));
    }
    [Symbol.iterator]() {
        return this.O(this.j);
    }
}

var _default = OrderedMap;

exports.default = _default;