"use strict";

Object.defineProperty(exports, "t", {
    value: true
});

exports.default = exports.OrderedSetIterator = void 0;

var _Base = _interopRequireDefault(require("./Base"));

var _TreeIterator = _interopRequireDefault(require("./Base/TreeIterator"));

function _interopRequireDefault(e) {
    return e && e.t ? e : {
        default: e
    };
}

class OrderedSetIterator extends _TreeIterator.default {
    get pointer() {
        if (this.I === this.L) {
            throw new RangeError("OrderedSet iterator access denied!");
        }
        return this.I.key;
    }
    copy() {
        return new OrderedSetIterator(this.I, this.L, this.iteratorType);
    }
}

exports.OrderedSetIterator = OrderedSetIterator;

class OrderedSet extends _Base.default {
    constructor(e = [], t, r) {
        super(t, r);
        this.O = function*(e) {
            if (e === undefined) return;
            yield* this.O(e.left);
            yield e.key;
            yield* this.O(e.right);
        };
        e.forEach((e => this.insert(e)));
    }
    begin() {
        return new OrderedSetIterator(this.L.left || this.L, this.L);
    }
    end() {
        return new OrderedSetIterator(this.L, this.L);
    }
    rBegin() {
        return new OrderedSetIterator(this.L.right || this.L, this.L, 1);
    }
    rEnd() {
        return new OrderedSetIterator(this.L, this.L, 1);
    }
    front() {
        return this.L.left ? this.L.left.key : undefined;
    }
    back() {
        return this.L.right ? this.L.right.key : undefined;
    }
    forEach(e) {
        let t = 0;
        for (const r of this) e(r, t++);
    }
    getElementByPos(e) {
        if (e < 0 || e > this.o - 1) {
            throw new RangeError;
        }
        let t;
        let r = 0;
        for (const i of this) {
            if (r === e) {
                t = i;
                break;
            }
            r += 1;
        }
        return t;
    }
    insert(e, t) {
        this.G(e, undefined, t);
    }
    find(e) {
        const t = this.H(this.j, e);
        if (t !== undefined) {
            return new OrderedSetIterator(t, this.L);
        }
        return this.end();
    }
    lowerBound(e) {
        const t = this.T(this.j, e);
        return new OrderedSetIterator(t, this.L);
    }
    upperBound(e) {
        const t = this.K(this.j, e);
        return new OrderedSetIterator(t, this.L);
    }
    reverseLowerBound(e) {
        const t = this.S(this.j, e);
        return new OrderedSetIterator(t, this.L);
    }
    reverseUpperBound(e) {
        const t = this.U(this.j, e);
        return new OrderedSetIterator(t, this.L);
    }
    union(e) {
        e.forEach((e => this.insert(e)));
    }
    [Symbol.iterator]() {
        return this.O(this.j);
    }
}

var _default = OrderedSet;

exports.default = _default;