import { Base } from "../../ContainerBase";
export declare const enum HashContainerConst {
    sigma = 0.75,
    treeifyThreshold = 8,
    untreeifyThreshold = 6,
    minTreeifySize = 64,
    maxBucketNum = 1073741824
}
declare abstract class HashContainer<K> extends Base {
    protected constructor(initBucketNum?: number, hashFunc?: (x: K) => number);
    clear(): void;
    abstract forEach(callback: (element: unknown, index: number) => void): void;
    /**
     * @description Remove the elements of the specified value.
     * @param key The element you want to remove.
     */
    abstract eraseElementByKey(key: K): void;
    /**
     * @param key The element you want to find.
     * @return Boolean about if the specified element in the hash set.
     */
    abstract find(key: K): void;
    abstract [Symbol.iterator](): Generator<unknown, void, undefined>;
}
export default HashContainer;
