var __extends = this && this.t || function() {
    var extendStatics = function(e, n) {
        extendStatics = Object.setPrototypeOf || {
            __proto__: []
        } instanceof Array && function(e, n) {
            e.__proto__ = n;
        } || function(e, n) {
            for (var i in n) if (Object.prototype.hasOwnProperty.call(n, i)) e[i] = n[i];
        };
        return extendStatics(e, n);
    };
    return function(e, n) {
        if (typeof n !== "function" && n !== null) throw new TypeError("Class extends value " + String(n) + " is not a constructor or null");
        extendStatics(e, n);
        function __() {
            this.constructor = e;
        }
        e.prototype = n === null ? Object.create(n) : (__.prototype = n.prototype, new __);
    };
}();

var TreeNode = function() {
    function TreeNode(e, n) {
        this.color = 1;
        this.key = undefined;
        this.value = undefined;
        this.left = undefined;
        this.right = undefined;
        this.parent = undefined;
        this.key = e;
        this.value = n;
    }
    TreeNode.prototype.pre = function() {
        var e = this;
        if (e.color === 1 && e.parent.parent === e) {
            e = e.right;
        } else if (e.left) {
            e = e.left;
            while (e.right) {
                e = e.right;
            }
        } else {
            var n = e.parent;
            while (n.left === e) {
                e = n;
                n = e.parent;
            }
            e = n;
        }
        return e;
    };
    TreeNode.prototype.next = function() {
        var e = this;
        if (e.right) {
            e = e.right;
            while (e.left) {
                e = e.left;
            }
        } else {
            var n = e.parent;
            while (n.right === e) {
                e = n;
                n = e.parent;
            }
            if (e.right !== n) {
                e = n;
            }
        }
        return e;
    };
    TreeNode.prototype.rotateLeft = function() {
        var e = this.parent;
        var n = this.right;
        var i = n.left;
        if (e.parent === this) e.parent = n; else if (e.left === this) e.left = n; else e.right = n;
        n.parent = e;
        n.left = this;
        this.parent = n;
        this.right = i;
        if (i) i.parent = this;
        return n;
    };
    TreeNode.prototype.rotateRight = function() {
        var e = this.parent;
        var n = this.left;
        var i = n.right;
        if (e.parent === this) e.parent = n; else if (e.left === this) e.left = n; else e.right = n;
        n.parent = e;
        n.right = this;
        this.parent = n;
        this.left = i;
        if (i) i.parent = this;
        return n;
    };
    return TreeNode;
}();

export { TreeNode };

var TreeNodeEnableIndex = function(e) {
    __extends(TreeNodeEnableIndex, e);
    function TreeNodeEnableIndex() {
        var n = e !== null && e.apply(this, arguments) || this;
        n.left = undefined;
        n.right = undefined;
        n.parent = undefined;
        n.subTreeSize = 1;
        return n;
    }
    TreeNodeEnableIndex.prototype.rotateLeft = function() {
        var n = e.prototype.rotateLeft.call(this);
        this.recount();
        n.recount();
        return n;
    };
    TreeNodeEnableIndex.prototype.rotateRight = function() {
        var n = e.prototype.rotateRight.call(this);
        this.recount();
        n.recount();
        return n;
    };
    TreeNodeEnableIndex.prototype.recount = function() {
        this.subTreeSize = 1;
        if (this.left) this.subTreeSize += this.left.subTreeSize;
        if (this.right) this.subTreeSize += this.right.subTreeSize;
    };
    return TreeNodeEnableIndex;
}(TreeNode);

export { TreeNodeEnableIndex };